import React, { MouseEvent } from 'react';
import { FlatListProps, SectionListProps, StyleProp, TouchableHighlightProps, ViewProps, VirtualizedListProps } from 'react-native';
import { FocusEventListener, BlurEventListener } from './features';
import type { CompleteStyle, Units } from './types';
export declare const defaultUnits: Units;
export declare const RemContext: React.Context<number>;
export declare const FontSizeContext: React.Context<number>;
export declare const SharedValue: React.Context<unknown>;
export interface DefaultTheme {
}
declare type Primitive = number | string | null | undefined | boolean | CompleteStyle;
declare type Functs<T> = (arg: T & {
    rnCSS?: string;
    shared: unknown;
    theme: DefaultTheme;
}) => Primitive;
declare type OptionalProps = {
    rnCSS?: `${string};`;
    onFocus?: FocusEventListener;
    onBlur?: BlurEventListener;
    onPressIn?: TouchableHighlightProps['onPressIn'];
    onPressOut?: TouchableHighlightProps['onPressOut'];
    onResponderStart?: ViewProps['onResponderStart'];
    onResponderRelease?: ViewProps['onResponderRelease'];
    onStartShouldSetResponder?: ViewProps['onStartShouldSetResponder'];
    onMouseEnter?: (event: MouseEvent) => void;
    onMouseLeave?: (event: MouseEvent) => void;
    onLayout?: ViewProps['onLayout'];
    children?: React.ReactNode;
};
declare const styled: <StyleType, InitialProps extends {
    style?: StyleProp<StyleType>;
}, Props extends InitialProps & OptionalProps = InitialProps & OptionalProps>(Component: React.ComponentType<InitialProps>) => {
    <S>(chunks: TemplateStringsArray, ...functs: (Primitive | Functs<S & Props>)[]): React.ForwardRefExoticComponent<Props & S & {
        ref?: React.Ref<any> | undefined;
    }>;
    attrs<Part, Result extends Partial<Props & Part> = Partial<Props & Part>>(opts: Result | ((props: Props & Part) => Result)): (chunks: TemplateStringsArray, ...functs: (Primitive | Functs<Props & Part>)[]) => React.ForwardRefExoticComponent<React.PropsWithoutRef<Omit<Props, keyof Result> & Part & Partial<Pick<Props, Extract<keyof Props, keyof Result>>>> & React.RefAttributes<any>>;
};
export default styled;
export declare const styledFlatList: {
    <S>(chunks: TemplateStringsArray, ...functs: (Primitive | Functs<S & FlatListProps<any> & OptionalProps>)[]): <Type>(props: S & OptionalProps & FlatListProps<Type>) => JSX.Element;
    attrs<S_1, Result extends Partial<S_1 & FlatListProps<any> & OptionalProps> = {}>(opts: Result | ((props: S_1 & OptionalProps & FlatListProps<any>) => Result)): (chunks: TemplateStringsArray, ...functs: (Primitive | Functs<S_1>)[]) => <Props>(componentProps: Omit<FlatListProps<Props> & OptionalProps, keyof Result> & S_1 & Partial<Result>) => JSX.Element;
};
export declare const styledSectionList: {
    <S>(chunks: TemplateStringsArray, ...functs: (Primitive | Functs<S & SectionListProps<any, import("react-native").DefaultSectionT> & OptionalProps>)[]): <Type>(props: S & OptionalProps & SectionListProps<Type, import("react-native").DefaultSectionT>) => JSX.Element;
    attrs<S_1, Result extends Partial<S_1 & SectionListProps<any, import("react-native").DefaultSectionT> & OptionalProps> = {}>(opts: Result | ((props: S_1 & OptionalProps & SectionListProps<any, import("react-native").DefaultSectionT>) => Result)): (chunks: TemplateStringsArray, ...functs: (Primitive | Functs<S_1>)[]) => <Props>(componentProps: Omit<SectionListProps<Props, import("react-native").DefaultSectionT> & OptionalProps, keyof Result> & S_1 & Partial<Result>) => JSX.Element;
};
export declare const styledVirtualizedList: {
    <S>(chunks: TemplateStringsArray, ...functs: (Primitive | Functs<S & VirtualizedListProps<any> & OptionalProps>)[]): <Type>(props: S & OptionalProps & VirtualizedListProps<Type>) => JSX.Element;
    attrs<S_1, Result extends Partial<S_1 & VirtualizedListProps<any> & OptionalProps> = {}>(opts: Result | ((props: S_1 & OptionalProps & VirtualizedListProps<any>) => Result)): (chunks: TemplateStringsArray, ...functs: (Primitive | Functs<S_1>)[]) => <Props>(componentProps: Omit<VirtualizedListProps<Props> & OptionalProps, keyof Result> & S_1 & Partial<Result>) => JSX.Element;
};
