import React from 'react';
import { DefaultTheme } from './styleComponent';
/** Provider for the theme. */
export declare const ThemeProvider: ({ theme, children }: {
    theme: DefaultTheme;
    children: React.ReactNode;
}) => JSX.Element;
/**
 * Returns the Theme
 * @returns The Theme object
 */
export declare const useTheme: () => unknown;
/**
 * Adds the theme prop to a non rn-css component
 * @param Component A non rn-css component
 * @returns A component with the theme prop
 */
export declare const withTheme: <T>(Component: React.ComponentType<T>) => React.ForwardRefExoticComponent<React.PropsWithoutRef<T> & React.RefAttributes<React.Component<{}, {}, any>>>;
