import React from 'react';
import * as RN from 'react-native';
import './polyfill';
export { cssToRNStyle } from './cssToRN';
export { SharedValue, FontSizeContext, RemContext, DefaultTheme } from './styleComponent';
export * from './useTheme';
declare const styled: {
    <StyleType, InitialProps extends {
        style?: RN.StyleProp<StyleType>;
    }>(Component: React.ComponentType<InitialProps>): {
        <S>(chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: S & InitialProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]): React.ForwardRefExoticComponent<InitialProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & S & {
            ref?: React.Ref<any> | undefined;
        }>;
        attrs<Part, Result extends Partial<InitialProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part> = Partial<InitialProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part>>(opts: Result | ((props: InitialProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part) => Result)): (chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: InitialProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]) => React.ForwardRefExoticComponent<React.PropsWithoutRef<Omit<InitialProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, keyof Result> & Part & Partial<Pick<InitialProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, Extract<"onFocus", keyof Result> | Extract<"onBlur", keyof Result> | Extract<"onPressIn", keyof Result> | Extract<"onPressOut", keyof Result> | Extract<"onResponderStart", keyof Result> | Extract<"onResponderRelease", keyof Result> | Extract<"onStartShouldSetResponder", keyof Result> | Extract<"onLayout", keyof Result> | Extract<"children", keyof Result> | Extract<"rnCSS", keyof Result> | Extract<"onMouseEnter", keyof Result> | Extract<"onMouseLeave", keyof Result> | Extract<keyof InitialProps, keyof Result>>>> & React.RefAttributes<any>>;
    };
    ActivityIndicator: {
        <S_1>(chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: S_1 & RN.ActivityIndicatorProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]): React.ForwardRefExoticComponent<RN.ActivityIndicatorProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & S_1 & {
            ref?: React.Ref<any> | undefined;
        }>;
        attrs<Part_1, Result_1 extends Partial<RN.ActivityIndicatorProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_1> = Partial<RN.ActivityIndicatorProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_1>>(opts: Result_1 | ((props: RN.ActivityIndicatorProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_1) => Result_1)): (chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: RN.ActivityIndicatorProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_1 & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]) => React.ForwardRefExoticComponent<React.PropsWithoutRef<Omit<RN.ActivityIndicatorProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, keyof Result_1> & Part_1 & Partial<Pick<RN.ActivityIndicatorProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, Extract<"testID", keyof Result_1> | Extract<"color", keyof Result_1> | Extract<"onFocus", keyof Result_1> | Extract<"onBlur", keyof Result_1> | Extract<"onPressIn", keyof Result_1> | Extract<"onPressOut", keyof Result_1> | Extract<"onResponderStart", keyof Result_1> | Extract<"onResponderRelease", keyof Result_1> | Extract<"onStartShouldSetResponder", keyof Result_1> | Extract<"onLayout", keyof Result_1> | Extract<"removeClippedSubviews", keyof Result_1> | Extract<"style", keyof Result_1> | Extract<"children", keyof Result_1> | Extract<"hitSlop", keyof Result_1> | Extract<"pointerEvents", keyof Result_1> | Extract<"nativeID", keyof Result_1> | Extract<"collapsable", keyof Result_1> | Extract<"needsOffscreenAlphaCompositing", keyof Result_1> | Extract<"renderToHardwareTextureAndroid", keyof Result_1> | Extract<"focusable", keyof Result_1> | Extract<"shouldRasterizeIOS", keyof Result_1> | Extract<"isTVSelectable", keyof Result_1> | Extract<"hasTVPreferredFocus", keyof Result_1> | Extract<"tvParallaxProperties", keyof Result_1> | Extract<"tvParallaxShiftDistanceX", keyof Result_1> | Extract<"tvParallaxShiftDistanceY", keyof Result_1> | Extract<"tvParallaxTiltAngle", keyof Result_1> | Extract<"tvParallaxMagnification", keyof Result_1> | Extract<"onMoveShouldSetResponder", keyof Result_1> | Extract<"onResponderEnd", keyof Result_1> | Extract<"onResponderGrant", keyof Result_1> | Extract<"onResponderReject", keyof Result_1> | Extract<"onResponderMove", keyof Result_1> | Extract<"onResponderTerminationRequest", keyof Result_1> | Extract<"onResponderTerminate", keyof Result_1> | Extract<"onStartShouldSetResponderCapture", keyof Result_1> | Extract<"onMoveShouldSetResponderCapture", keyof Result_1> | Extract<"onTouchStart", keyof Result_1> | Extract<"onTouchMove", keyof Result_1> | Extract<"onTouchEnd", keyof Result_1> | Extract<"onTouchCancel", keyof Result_1> | Extract<"onTouchEndCapture", keyof Result_1> | Extract<"accessible", keyof Result_1> | Extract<"accessibilityActions", keyof Result_1> | Extract<"accessibilityLabel", keyof Result_1> | Extract<"accessibilityRole", keyof Result_1> | Extract<"accessibilityState", keyof Result_1> | Extract<"accessibilityHint", keyof Result_1> | Extract<"accessibilityValue", keyof Result_1> | Extract<"onAccessibilityAction", keyof Result_1> | Extract<"accessibilityLiveRegion", keyof Result_1> | Extract<"importantForAccessibility", keyof Result_1> | Extract<"accessibilityElementsHidden", keyof Result_1> | Extract<"accessibilityViewIsModal", keyof Result_1> | Extract<"onAccessibilityEscape", keyof Result_1> | Extract<"onAccessibilityTap", keyof Result_1> | Extract<"onMagicTap", keyof Result_1> | Extract<"accessibilityIgnoresInvertColors", keyof Result_1> | Extract<"rnCSS", keyof Result_1> | Extract<"onMouseEnter", keyof Result_1> | Extract<"onMouseLeave", keyof Result_1> | Extract<"animating", keyof Result_1> | Extract<"hidesWhenStopped", keyof Result_1> | Extract<"size", keyof Result_1>>>> & React.RefAttributes<any>>;
    };
    DrawerLayoutAndroid: {
        <S_2>(chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: S_2 & RN.DrawerLayoutAndroidProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]): React.ForwardRefExoticComponent<RN.DrawerLayoutAndroidProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & S_2 & {
            ref?: React.Ref<any> | undefined;
        }>;
        attrs<Part_2, Result_2 extends Partial<RN.DrawerLayoutAndroidProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_2> = Partial<RN.DrawerLayoutAndroidProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_2>>(opts: Result_2 | ((props: RN.DrawerLayoutAndroidProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_2) => Result_2)): (chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: RN.DrawerLayoutAndroidProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_2 & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]) => React.ForwardRefExoticComponent<React.PropsWithoutRef<Omit<RN.DrawerLayoutAndroidProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, keyof Result_2> & Part_2 & Partial<Pick<RN.DrawerLayoutAndroidProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, Extract<"testID", keyof Result_2> | Extract<"onFocus", keyof Result_2> | Extract<"onBlur", keyof Result_2> | Extract<"onPressIn", keyof Result_2> | Extract<"onPressOut", keyof Result_2> | Extract<"onResponderStart", keyof Result_2> | Extract<"onResponderRelease", keyof Result_2> | Extract<"onStartShouldSetResponder", keyof Result_2> | Extract<"onLayout", keyof Result_2> | Extract<"removeClippedSubviews", keyof Result_2> | Extract<"keyboardDismissMode", keyof Result_2> | Extract<"style", keyof Result_2> | Extract<"children", keyof Result_2> | Extract<"hitSlop", keyof Result_2> | Extract<"pointerEvents", keyof Result_2> | Extract<"nativeID", keyof Result_2> | Extract<"collapsable", keyof Result_2> | Extract<"needsOffscreenAlphaCompositing", keyof Result_2> | Extract<"renderToHardwareTextureAndroid", keyof Result_2> | Extract<"focusable", keyof Result_2> | Extract<"shouldRasterizeIOS", keyof Result_2> | Extract<"isTVSelectable", keyof Result_2> | Extract<"hasTVPreferredFocus", keyof Result_2> | Extract<"tvParallaxProperties", keyof Result_2> | Extract<"tvParallaxShiftDistanceX", keyof Result_2> | Extract<"tvParallaxShiftDistanceY", keyof Result_2> | Extract<"tvParallaxTiltAngle", keyof Result_2> | Extract<"tvParallaxMagnification", keyof Result_2> | Extract<"onMoveShouldSetResponder", keyof Result_2> | Extract<"onResponderEnd", keyof Result_2> | Extract<"onResponderGrant", keyof Result_2> | Extract<"onResponderReject", keyof Result_2> | Extract<"onResponderMove", keyof Result_2> | Extract<"onResponderTerminationRequest", keyof Result_2> | Extract<"onResponderTerminate", keyof Result_2> | Extract<"onStartShouldSetResponderCapture", keyof Result_2> | Extract<"onMoveShouldSetResponderCapture", keyof Result_2> | Extract<"onTouchStart", keyof Result_2> | Extract<"onTouchMove", keyof Result_2> | Extract<"onTouchEnd", keyof Result_2> | Extract<"onTouchCancel", keyof Result_2> | Extract<"onTouchEndCapture", keyof Result_2> | Extract<"accessible", keyof Result_2> | Extract<"accessibilityActions", keyof Result_2> | Extract<"accessibilityLabel", keyof Result_2> | Extract<"accessibilityRole", keyof Result_2> | Extract<"accessibilityState", keyof Result_2> | Extract<"accessibilityHint", keyof Result_2> | Extract<"accessibilityValue", keyof Result_2> | Extract<"onAccessibilityAction", keyof Result_2> | Extract<"accessibilityLiveRegion", keyof Result_2> | Extract<"importantForAccessibility", keyof Result_2> | Extract<"accessibilityElementsHidden", keyof Result_2> | Extract<"accessibilityViewIsModal", keyof Result_2> | Extract<"onAccessibilityEscape", keyof Result_2> | Extract<"onAccessibilityTap", keyof Result_2> | Extract<"onMagicTap", keyof Result_2> | Extract<"accessibilityIgnoresInvertColors", keyof Result_2> | Extract<"rnCSS", keyof Result_2> | Extract<"onMouseEnter", keyof Result_2> | Extract<"onMouseLeave", keyof Result_2> | Extract<"drawerBackgroundColor", keyof Result_2> | Extract<"drawerLockMode", keyof Result_2> | Extract<"drawerPosition", keyof Result_2> | Extract<"drawerWidth", keyof Result_2> | Extract<"onDrawerClose", keyof Result_2> | Extract<"onDrawerOpen", keyof Result_2> | Extract<"onDrawerSlide", keyof Result_2> | Extract<"onDrawerStateChanged", keyof Result_2> | Extract<"renderNavigationView", keyof Result_2> | Extract<"statusBarBackgroundColor", keyof Result_2>>>> & React.RefAttributes<any>>;
    };
    Image: {
        <S_3>(chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: S_3 & RN.ImageProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]): React.ForwardRefExoticComponent<RN.ImageProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & S_3 & {
            ref?: React.Ref<any> | undefined;
        }>;
        attrs<Part_3, Result_3 extends Partial<RN.ImageProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_3> = Partial<RN.ImageProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_3>>(opts: Result_3 | ((props: RN.ImageProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_3) => Result_3)): (chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: RN.ImageProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_3 & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]) => React.ForwardRefExoticComponent<React.PropsWithoutRef<Omit<RN.ImageProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, keyof Result_3> & Part_3 & Partial<Pick<RN.ImageProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, Extract<"borderBottomLeftRadius", keyof Result_3> | Extract<"borderBottomRightRadius", keyof Result_3> | Extract<"borderRadius", keyof Result_3> | Extract<"borderTopLeftRadius", keyof Result_3> | Extract<"borderTopRightRadius", keyof Result_3> | Extract<"testID", keyof Result_3> | Extract<"height", keyof Result_3> | Extract<"width", keyof Result_3> | Extract<"resizeMode", keyof Result_3> | Extract<"onFocus", keyof Result_3> | Extract<"onBlur", keyof Result_3> | Extract<"onPressIn", keyof Result_3> | Extract<"onPressOut", keyof Result_3> | Extract<"onResponderStart", keyof Result_3> | Extract<"onResponderRelease", keyof Result_3> | Extract<"onStartShouldSetResponder", keyof Result_3> | Extract<"onLayout", keyof Result_3> | Extract<"style", keyof Result_3> | Extract<"children", keyof Result_3> | Extract<"nativeID", keyof Result_3> | Extract<"accessible", keyof Result_3> | Extract<"accessibilityActions", keyof Result_3> | Extract<"accessibilityLabel", keyof Result_3> | Extract<"accessibilityRole", keyof Result_3> | Extract<"accessibilityState", keyof Result_3> | Extract<"accessibilityHint", keyof Result_3> | Extract<"accessibilityValue", keyof Result_3> | Extract<"onAccessibilityAction", keyof Result_3> | Extract<"accessibilityLiveRegion", keyof Result_3> | Extract<"importantForAccessibility", keyof Result_3> | Extract<"accessibilityElementsHidden", keyof Result_3> | Extract<"accessibilityViewIsModal", keyof Result_3> | Extract<"onAccessibilityEscape", keyof Result_3> | Extract<"onAccessibilityTap", keyof Result_3> | Extract<"onMagicTap", keyof Result_3> | Extract<"accessibilityIgnoresInvertColors", keyof Result_3> | Extract<"rnCSS", keyof Result_3> | Extract<"onMouseEnter", keyof Result_3> | Extract<"onMouseLeave", keyof Result_3> | Extract<"source", keyof Result_3> | Extract<"onError", keyof Result_3> | Extract<"onLoad", keyof Result_3> | Extract<"onLoadEnd", keyof Result_3> | Extract<"onLoadStart", keyof Result_3> | Extract<"progressiveRenderingEnabled", keyof Result_3> | Extract<"resizeMethod", keyof Result_3> | Extract<"loadingIndicatorSource", keyof Result_3> | Extract<"defaultSource", keyof Result_3> | Extract<"blurRadius", keyof Result_3> | Extract<"capInsets", keyof Result_3> | Extract<"onProgress", keyof Result_3> | Extract<"onPartialLoad", keyof Result_3> | Extract<"fadeDuration", keyof Result_3>>>> & React.RefAttributes<any>>;
    };
    ImageBackground: {
        <S_4>(chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: S_4 & RN.ImageBackgroundProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]): React.ForwardRefExoticComponent<RN.ImageBackgroundProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & S_4 & {
            ref?: React.Ref<any> | undefined;
        }>;
        attrs<Part_4, Result_4 extends Partial<RN.ImageBackgroundProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_4> = Partial<RN.ImageBackgroundProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_4>>(opts: Result_4 | ((props: RN.ImageBackgroundProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_4) => Result_4)): (chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: RN.ImageBackgroundProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_4 & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]) => React.ForwardRefExoticComponent<React.PropsWithoutRef<Omit<RN.ImageBackgroundProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, keyof Result_4> & Part_4 & Partial<Pick<RN.ImageBackgroundProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, Extract<"borderBottomLeftRadius", keyof Result_4> | Extract<"borderBottomRightRadius", keyof Result_4> | Extract<"borderRadius", keyof Result_4> | Extract<"borderTopLeftRadius", keyof Result_4> | Extract<"borderTopRightRadius", keyof Result_4> | Extract<"testID", keyof Result_4> | Extract<"height", keyof Result_4> | Extract<"width", keyof Result_4> | Extract<"resizeMode", keyof Result_4> | Extract<"onFocus", keyof Result_4> | Extract<"onBlur", keyof Result_4> | Extract<"onPressIn", keyof Result_4> | Extract<"onPressOut", keyof Result_4> | Extract<"onResponderStart", keyof Result_4> | Extract<"onResponderRelease", keyof Result_4> | Extract<"onStartShouldSetResponder", keyof Result_4> | Extract<"onLayout", keyof Result_4> | Extract<"style", keyof Result_4> | Extract<"children", keyof Result_4> | Extract<"nativeID", keyof Result_4> | Extract<"accessible", keyof Result_4> | Extract<"accessibilityActions", keyof Result_4> | Extract<"accessibilityLabel", keyof Result_4> | Extract<"accessibilityRole", keyof Result_4> | Extract<"accessibilityState", keyof Result_4> | Extract<"accessibilityHint", keyof Result_4> | Extract<"accessibilityValue", keyof Result_4> | Extract<"onAccessibilityAction", keyof Result_4> | Extract<"accessibilityLiveRegion", keyof Result_4> | Extract<"importantForAccessibility", keyof Result_4> | Extract<"accessibilityElementsHidden", keyof Result_4> | Extract<"accessibilityViewIsModal", keyof Result_4> | Extract<"onAccessibilityEscape", keyof Result_4> | Extract<"onAccessibilityTap", keyof Result_4> | Extract<"onMagicTap", keyof Result_4> | Extract<"accessibilityIgnoresInvertColors", keyof Result_4> | Extract<"rnCSS", keyof Result_4> | Extract<"onMouseEnter", keyof Result_4> | Extract<"onMouseLeave", keyof Result_4> | Extract<"source", keyof Result_4> | Extract<"onError", keyof Result_4> | Extract<"onLoad", keyof Result_4> | Extract<"onLoadEnd", keyof Result_4> | Extract<"onLoadStart", keyof Result_4> | Extract<"progressiveRenderingEnabled", keyof Result_4> | Extract<"resizeMethod", keyof Result_4> | Extract<"loadingIndicatorSource", keyof Result_4> | Extract<"defaultSource", keyof Result_4> | Extract<"blurRadius", keyof Result_4> | Extract<"capInsets", keyof Result_4> | Extract<"onProgress", keyof Result_4> | Extract<"onPartialLoad", keyof Result_4> | Extract<"fadeDuration", keyof Result_4> | Extract<"imageStyle", keyof Result_4> | Extract<"imageRef", keyof Result_4>>>> & React.RefAttributes<any>>;
    };
    KeyboardAvoidingView: {
        <S_5>(chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: S_5 & RN.KeyboardAvoidingViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]): React.ForwardRefExoticComponent<RN.KeyboardAvoidingViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & S_5 & {
            ref?: React.Ref<any> | undefined;
        }>;
        attrs<Part_5, Result_5 extends Partial<RN.KeyboardAvoidingViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_5> = Partial<RN.KeyboardAvoidingViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_5>>(opts: Result_5 | ((props: RN.KeyboardAvoidingViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_5) => Result_5)): (chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: RN.KeyboardAvoidingViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_5 & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]) => React.ForwardRefExoticComponent<React.PropsWithoutRef<Omit<RN.KeyboardAvoidingViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, keyof Result_5> & Part_5 & Partial<Pick<RN.KeyboardAvoidingViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, Extract<"enabled", keyof Result_5> | Extract<"testID", keyof Result_5> | Extract<"onFocus", keyof Result_5> | Extract<"onBlur", keyof Result_5> | Extract<"onPressIn", keyof Result_5> | Extract<"onPressOut", keyof Result_5> | Extract<"onResponderStart", keyof Result_5> | Extract<"onResponderRelease", keyof Result_5> | Extract<"onStartShouldSetResponder", keyof Result_5> | Extract<"onLayout", keyof Result_5> | Extract<"removeClippedSubviews", keyof Result_5> | Extract<"contentContainerStyle", keyof Result_5> | Extract<"style", keyof Result_5> | Extract<"children", keyof Result_5> | Extract<"hitSlop", keyof Result_5> | Extract<"pointerEvents", keyof Result_5> | Extract<"nativeID", keyof Result_5> | Extract<"collapsable", keyof Result_5> | Extract<"needsOffscreenAlphaCompositing", keyof Result_5> | Extract<"renderToHardwareTextureAndroid", keyof Result_5> | Extract<"focusable", keyof Result_5> | Extract<"shouldRasterizeIOS", keyof Result_5> | Extract<"isTVSelectable", keyof Result_5> | Extract<"hasTVPreferredFocus", keyof Result_5> | Extract<"tvParallaxProperties", keyof Result_5> | Extract<"tvParallaxShiftDistanceX", keyof Result_5> | Extract<"tvParallaxShiftDistanceY", keyof Result_5> | Extract<"tvParallaxTiltAngle", keyof Result_5> | Extract<"tvParallaxMagnification", keyof Result_5> | Extract<"onMoveShouldSetResponder", keyof Result_5> | Extract<"onResponderEnd", keyof Result_5> | Extract<"onResponderGrant", keyof Result_5> | Extract<"onResponderReject", keyof Result_5> | Extract<"onResponderMove", keyof Result_5> | Extract<"onResponderTerminationRequest", keyof Result_5> | Extract<"onResponderTerminate", keyof Result_5> | Extract<"onStartShouldSetResponderCapture", keyof Result_5> | Extract<"onMoveShouldSetResponderCapture", keyof Result_5> | Extract<"onTouchStart", keyof Result_5> | Extract<"onTouchMove", keyof Result_5> | Extract<"onTouchEnd", keyof Result_5> | Extract<"onTouchCancel", keyof Result_5> | Extract<"onTouchEndCapture", keyof Result_5> | Extract<"accessible", keyof Result_5> | Extract<"accessibilityActions", keyof Result_5> | Extract<"accessibilityLabel", keyof Result_5> | Extract<"accessibilityRole", keyof Result_5> | Extract<"accessibilityState", keyof Result_5> | Extract<"accessibilityHint", keyof Result_5> | Extract<"accessibilityValue", keyof Result_5> | Extract<"onAccessibilityAction", keyof Result_5> | Extract<"accessibilityLiveRegion", keyof Result_5> | Extract<"importantForAccessibility", keyof Result_5> | Extract<"accessibilityElementsHidden", keyof Result_5> | Extract<"accessibilityViewIsModal", keyof Result_5> | Extract<"onAccessibilityEscape", keyof Result_5> | Extract<"onAccessibilityTap", keyof Result_5> | Extract<"onMagicTap", keyof Result_5> | Extract<"accessibilityIgnoresInvertColors", keyof Result_5> | Extract<"rnCSS", keyof Result_5> | Extract<"onMouseEnter", keyof Result_5> | Extract<"onMouseLeave", keyof Result_5> | Extract<"behavior", keyof Result_5> | Extract<"keyboardVerticalOffset", keyof Result_5>>>> & React.RefAttributes<any>>;
    };
    Modal: {
        <S_6>(chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: S_6 & RN.ModalBaseProps & RN.ModalPropsIOS & RN.ModalPropsAndroid & RN.ViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]): React.ForwardRefExoticComponent<RN.ModalBaseProps & RN.ModalPropsIOS & RN.ModalPropsAndroid & RN.ViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & S_6 & {
            ref?: React.Ref<any> | undefined;
        }>;
        attrs<Part_6, Result_6 extends Partial<RN.ModalBaseProps & RN.ModalPropsIOS & RN.ModalPropsAndroid & RN.ViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_6> = Partial<RN.ModalBaseProps & RN.ModalPropsIOS & RN.ModalPropsAndroid & RN.ViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_6>>(opts: Result_6 | ((props: RN.ModalBaseProps & RN.ModalPropsIOS & RN.ModalPropsAndroid & RN.ViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_6) => Result_6)): (chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: RN.ModalBaseProps & RN.ModalPropsIOS & RN.ModalPropsAndroid & RN.ViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_6 & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]) => React.ForwardRefExoticComponent<React.PropsWithoutRef<Omit<RN.ModalBaseProps & RN.ModalPropsIOS & RN.ModalPropsAndroid & RN.ViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, keyof Result_6> & Part_6 & Partial<Pick<RN.ModalBaseProps & RN.ModalPropsIOS & RN.ModalPropsAndroid & RN.ViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, Extract<"visible", keyof Result_6> | Extract<"testID", keyof Result_6> | Extract<"onFocus", keyof Result_6> | Extract<"onBlur", keyof Result_6> | Extract<"transparent", keyof Result_6> | Extract<"onPressIn", keyof Result_6> | Extract<"onPressOut", keyof Result_6> | Extract<"onResponderStart", keyof Result_6> | Extract<"onResponderRelease", keyof Result_6> | Extract<"onStartShouldSetResponder", keyof Result_6> | Extract<"onLayout", keyof Result_6> | Extract<"removeClippedSubviews", keyof Result_6> | Extract<"style", keyof Result_6> | Extract<"children", keyof Result_6> | Extract<"hitSlop", keyof Result_6> | Extract<"pointerEvents", keyof Result_6> | Extract<"nativeID", keyof Result_6> | Extract<"collapsable", keyof Result_6> | Extract<"needsOffscreenAlphaCompositing", keyof Result_6> | Extract<"renderToHardwareTextureAndroid", keyof Result_6> | Extract<"focusable", keyof Result_6> | Extract<"shouldRasterizeIOS", keyof Result_6> | Extract<"isTVSelectable", keyof Result_6> | Extract<"hasTVPreferredFocus", keyof Result_6> | Extract<"tvParallaxProperties", keyof Result_6> | Extract<"tvParallaxShiftDistanceX", keyof Result_6> | Extract<"tvParallaxShiftDistanceY", keyof Result_6> | Extract<"tvParallaxTiltAngle", keyof Result_6> | Extract<"tvParallaxMagnification", keyof Result_6> | Extract<"onMoveShouldSetResponder", keyof Result_6> | Extract<"onResponderEnd", keyof Result_6> | Extract<"onResponderGrant", keyof Result_6> | Extract<"onResponderReject", keyof Result_6> | Extract<"onResponderMove", keyof Result_6> | Extract<"onResponderTerminationRequest", keyof Result_6> | Extract<"onResponderTerminate", keyof Result_6> | Extract<"onStartShouldSetResponderCapture", keyof Result_6> | Extract<"onMoveShouldSetResponderCapture", keyof Result_6> | Extract<"onTouchStart", keyof Result_6> | Extract<"onTouchMove", keyof Result_6> | Extract<"onTouchEnd", keyof Result_6> | Extract<"onTouchCancel", keyof Result_6> | Extract<"onTouchEndCapture", keyof Result_6> | Extract<"accessible", keyof Result_6> | Extract<"accessibilityActions", keyof Result_6> | Extract<"accessibilityLabel", keyof Result_6> | Extract<"accessibilityRole", keyof Result_6> | Extract<"accessibilityState", keyof Result_6> | Extract<"accessibilityHint", keyof Result_6> | Extract<"accessibilityValue", keyof Result_6> | Extract<"onAccessibilityAction", keyof Result_6> | Extract<"accessibilityLiveRegion", keyof Result_6> | Extract<"importantForAccessibility", keyof Result_6> | Extract<"accessibilityElementsHidden", keyof Result_6> | Extract<"accessibilityViewIsModal", keyof Result_6> | Extract<"onAccessibilityEscape", keyof Result_6> | Extract<"onAccessibilityTap", keyof Result_6> | Extract<"onMagicTap", keyof Result_6> | Extract<"accessibilityIgnoresInvertColors", keyof Result_6> | Extract<"rnCSS", keyof Result_6> | Extract<"onMouseEnter", keyof Result_6> | Extract<"onMouseLeave", keyof Result_6> | Extract<"animated", keyof Result_6> | Extract<"animationType", keyof Result_6> | Extract<"onRequestClose", keyof Result_6> | Extract<"onShow", keyof Result_6> | Extract<"presentationStyle", keyof Result_6> | Extract<"supportedOrientations", keyof Result_6> | Extract<"onDismiss", keyof Result_6> | Extract<"onOrientationChange", keyof Result_6> | Extract<"hardwareAccelerated", keyof Result_6> | Extract<"statusBarTranslucent", keyof Result_6>>>> & React.RefAttributes<any>>;
    };
    NavigatorIOS: {
        <S_7>(chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: S_7 & RN.NavigatorIOSProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]): React.ForwardRefExoticComponent<RN.NavigatorIOSProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & S_7 & {
            ref?: React.Ref<any> | undefined;
        }>;
        attrs<Part_7, Result_7 extends Partial<RN.NavigatorIOSProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_7> = Partial<RN.NavigatorIOSProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_7>>(opts: Result_7 | ((props: RN.NavigatorIOSProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_7) => Result_7)): (chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: RN.NavigatorIOSProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_7 & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]) => React.ForwardRefExoticComponent<React.PropsWithoutRef<Omit<RN.NavigatorIOSProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, keyof Result_7> & Part_7 & Partial<Pick<RN.NavigatorIOSProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, Extract<"onFocus", keyof Result_7> | Extract<"onBlur", keyof Result_7> | Extract<"onPressIn", keyof Result_7> | Extract<"onPressOut", keyof Result_7> | Extract<"onResponderStart", keyof Result_7> | Extract<"onResponderRelease", keyof Result_7> | Extract<"onStartShouldSetResponder", keyof Result_7> | Extract<"onLayout", keyof Result_7> | Extract<"children", keyof Result_7> | Extract<"rnCSS", keyof Result_7> | Extract<"onMouseEnter", keyof Result_7> | Extract<"onMouseLeave", keyof Result_7> | Extract<"tintColor", keyof Result_7> | Extract<"style", keyof Result_7> | Extract<"barTintColor", keyof Result_7> | Extract<"initialRoute", keyof Result_7> | Extract<"itemWrapperStyle", keyof Result_7> | Extract<"interactivePopGestureEnabled", keyof Result_7> | Extract<"navigationBarHidden", keyof Result_7> | Extract<"shadowHidden", keyof Result_7> | Extract<"titleTextColor", keyof Result_7> | Extract<"translucent", keyof Result_7>>>> & React.RefAttributes<any>>;
    };
    ScrollView: {
        <S_8>(chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: S_8 & RN.ScrollViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]): React.ForwardRefExoticComponent<RN.ScrollViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & S_8 & {
            ref?: React.Ref<any> | undefined;
        }>;
        attrs<Part_8, Result_8 extends Partial<RN.ScrollViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_8> = Partial<RN.ScrollViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_8>>(opts: Result_8 | ((props: RN.ScrollViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_8) => Result_8)): (chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: RN.ScrollViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_8 & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]) => React.ForwardRefExoticComponent<React.PropsWithoutRef<Omit<RN.ScrollViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, keyof Result_8> & Part_8 & Partial<Pick<RN.ScrollViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, Extract<"testID", keyof Result_8> | Extract<"onFocus", keyof Result_8> | Extract<"onBlur", keyof Result_8> | Extract<"onPressIn", keyof Result_8> | Extract<"onPressOut", keyof Result_8> | Extract<"onResponderStart", keyof Result_8> | Extract<"onResponderRelease", keyof Result_8> | Extract<"onStartShouldSetResponder", keyof Result_8> | Extract<"onLayout", keyof Result_8> | Extract<"keyboardShouldPersistTaps", keyof Result_8> | Extract<"horizontal", keyof Result_8> | Extract<"removeClippedSubviews", keyof Result_8> | Extract<"fadingEdgeLength", keyof Result_8> | Extract<"contentContainerStyle", keyof Result_8> | Extract<"decelerationRate", keyof Result_8> | Extract<"invertStickyHeaders", keyof Result_8> | Extract<"keyboardDismissMode", keyof Result_8> | Extract<"onContentSizeChange", keyof Result_8> | Extract<"onScroll", keyof Result_8> | Extract<"onScrollBeginDrag", keyof Result_8> | Extract<"onScrollEndDrag", keyof Result_8> | Extract<"onMomentumScrollEnd", keyof Result_8> | Extract<"onMomentumScrollBegin", keyof Result_8> | Extract<"pagingEnabled", keyof Result_8> | Extract<"scrollEnabled", keyof Result_8> | Extract<"showsHorizontalScrollIndicator", keyof Result_8> | Extract<"showsVerticalScrollIndicator", keyof Result_8> | Extract<"stickyHeaderHiddenOnScroll", keyof Result_8> | Extract<"style", keyof Result_8> | Extract<"refreshControl", keyof Result_8> | Extract<"snapToInterval", keyof Result_8> | Extract<"snapToOffsets", keyof Result_8> | Extract<"snapToStart", keyof Result_8> | Extract<"snapToEnd", keyof Result_8> | Extract<"stickyHeaderIndices", keyof Result_8> | Extract<"disableIntervalMomentum", keyof Result_8> | Extract<"disableScrollViewPanResponder", keyof Result_8> | Extract<"StickyHeaderComponent", keyof Result_8> | Extract<"children", keyof Result_8> | Extract<"hitSlop", keyof Result_8> | Extract<"pointerEvents", keyof Result_8> | Extract<"nativeID", keyof Result_8> | Extract<"collapsable", keyof Result_8> | Extract<"needsOffscreenAlphaCompositing", keyof Result_8> | Extract<"renderToHardwareTextureAndroid", keyof Result_8> | Extract<"focusable", keyof Result_8> | Extract<"shouldRasterizeIOS", keyof Result_8> | Extract<"isTVSelectable", keyof Result_8> | Extract<"hasTVPreferredFocus", keyof Result_8> | Extract<"tvParallaxProperties", keyof Result_8> | Extract<"tvParallaxShiftDistanceX", keyof Result_8> | Extract<"tvParallaxShiftDistanceY", keyof Result_8> | Extract<"tvParallaxTiltAngle", keyof Result_8> | Extract<"tvParallaxMagnification", keyof Result_8> | Extract<"onMoveShouldSetResponder", keyof Result_8> | Extract<"onResponderEnd", keyof Result_8> | Extract<"onResponderGrant", keyof Result_8> | Extract<"onResponderReject", keyof Result_8> | Extract<"onResponderMove", keyof Result_8> | Extract<"onResponderTerminationRequest", keyof Result_8> | Extract<"onResponderTerminate", keyof Result_8> | Extract<"onStartShouldSetResponderCapture", keyof Result_8> | Extract<"onMoveShouldSetResponderCapture", keyof Result_8> | Extract<"onTouchStart", keyof Result_8> | Extract<"onTouchMove", keyof Result_8> | Extract<"onTouchEnd", keyof Result_8> | Extract<"onTouchCancel", keyof Result_8> | Extract<"onTouchEndCapture", keyof Result_8> | Extract<"accessible", keyof Result_8> | Extract<"accessibilityActions", keyof Result_8> | Extract<"accessibilityLabel", keyof Result_8> | Extract<"accessibilityRole", keyof Result_8> | Extract<"accessibilityState", keyof Result_8> | Extract<"accessibilityHint", keyof Result_8> | Extract<"accessibilityValue", keyof Result_8> | Extract<"onAccessibilityAction", keyof Result_8> | Extract<"accessibilityLiveRegion", keyof Result_8> | Extract<"importantForAccessibility", keyof Result_8> | Extract<"accessibilityElementsHidden", keyof Result_8> | Extract<"accessibilityViewIsModal", keyof Result_8> | Extract<"onAccessibilityEscape", keyof Result_8> | Extract<"onAccessibilityTap", keyof Result_8> | Extract<"onMagicTap", keyof Result_8> | Extract<"accessibilityIgnoresInvertColors", keyof Result_8> | Extract<"alwaysBounceHorizontal", keyof Result_8> | Extract<"alwaysBounceVertical", keyof Result_8> | Extract<"automaticallyAdjustContentInsets", keyof Result_8> | Extract<"bounces", keyof Result_8> | Extract<"bouncesZoom", keyof Result_8> | Extract<"canCancelContentTouches", keyof Result_8> | Extract<"centerContent", keyof Result_8> | Extract<"contentInset", keyof Result_8> | Extract<"contentOffset", keyof Result_8> | Extract<"contentInsetAdjustmentBehavior", keyof Result_8> | Extract<"directionalLockEnabled", keyof Result_8> | Extract<"indicatorStyle", keyof Result_8> | Extract<"maintainVisibleContentPosition", keyof Result_8> | Extract<"maximumZoomScale", keyof Result_8> | Extract<"minimumZoomScale", keyof Result_8> | Extract<"onScrollAnimationEnd", keyof Result_8> | Extract<"pinchGestureEnabled", keyof Result_8> | Extract<"scrollEventThrottle", keyof Result_8> | Extract<"scrollIndicatorInsets", keyof Result_8> | Extract<"scrollToOverflowEnabled", keyof Result_8> | Extract<"scrollsToTop", keyof Result_8> | Extract<"snapToAlignment", keyof Result_8> | Extract<"onScrollToTop", keyof Result_8> | Extract<"zoomScale", keyof Result_8> | Extract<"endFillColor", keyof Result_8> | Extract<"scrollPerfTag", keyof Result_8> | Extract<"overScrollMode", keyof Result_8> | Extract<"nestedScrollEnabled", keyof Result_8> | Extract<"persistentScrollbar", keyof Result_8> | Extract<"rnCSS", keyof Result_8> | Extract<"onMouseEnter", keyof Result_8> | Extract<"onMouseLeave", keyof Result_8>>>> & React.RefAttributes<any>>;
    };
    SnapshotViewIOS: {
        <S_9>(chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: S_9 & RN.SnapshotViewIOSProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]): React.ForwardRefExoticComponent<RN.SnapshotViewIOSProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & S_9 & {
            ref?: React.Ref<any> | undefined;
        }>;
        attrs<Part_9, Result_9 extends Partial<RN.SnapshotViewIOSProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_9> = Partial<RN.SnapshotViewIOSProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_9>>(opts: Result_9 | ((props: RN.SnapshotViewIOSProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_9) => Result_9)): (chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: RN.SnapshotViewIOSProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_9 & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]) => React.ForwardRefExoticComponent<React.PropsWithoutRef<Omit<RN.SnapshotViewIOSProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, keyof Result_9> & Part_9 & Partial<Pick<RN.SnapshotViewIOSProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, Extract<"testID", keyof Result_9> | Extract<"onFocus", keyof Result_9> | Extract<"onBlur", keyof Result_9> | Extract<"onPressIn", keyof Result_9> | Extract<"onPressOut", keyof Result_9> | Extract<"onResponderStart", keyof Result_9> | Extract<"onResponderRelease", keyof Result_9> | Extract<"onStartShouldSetResponder", keyof Result_9> | Extract<"onLayout", keyof Result_9> | Extract<"removeClippedSubviews", keyof Result_9> | Extract<"style", keyof Result_9> | Extract<"children", keyof Result_9> | Extract<"hitSlop", keyof Result_9> | Extract<"pointerEvents", keyof Result_9> | Extract<"nativeID", keyof Result_9> | Extract<"collapsable", keyof Result_9> | Extract<"needsOffscreenAlphaCompositing", keyof Result_9> | Extract<"renderToHardwareTextureAndroid", keyof Result_9> | Extract<"focusable", keyof Result_9> | Extract<"shouldRasterizeIOS", keyof Result_9> | Extract<"isTVSelectable", keyof Result_9> | Extract<"hasTVPreferredFocus", keyof Result_9> | Extract<"tvParallaxProperties", keyof Result_9> | Extract<"tvParallaxShiftDistanceX", keyof Result_9> | Extract<"tvParallaxShiftDistanceY", keyof Result_9> | Extract<"tvParallaxTiltAngle", keyof Result_9> | Extract<"tvParallaxMagnification", keyof Result_9> | Extract<"onMoveShouldSetResponder", keyof Result_9> | Extract<"onResponderEnd", keyof Result_9> | Extract<"onResponderGrant", keyof Result_9> | Extract<"onResponderReject", keyof Result_9> | Extract<"onResponderMove", keyof Result_9> | Extract<"onResponderTerminationRequest", keyof Result_9> | Extract<"onResponderTerminate", keyof Result_9> | Extract<"onStartShouldSetResponderCapture", keyof Result_9> | Extract<"onMoveShouldSetResponderCapture", keyof Result_9> | Extract<"onTouchStart", keyof Result_9> | Extract<"onTouchMove", keyof Result_9> | Extract<"onTouchEnd", keyof Result_9> | Extract<"onTouchCancel", keyof Result_9> | Extract<"onTouchEndCapture", keyof Result_9> | Extract<"accessible", keyof Result_9> | Extract<"accessibilityActions", keyof Result_9> | Extract<"accessibilityLabel", keyof Result_9> | Extract<"accessibilityRole", keyof Result_9> | Extract<"accessibilityState", keyof Result_9> | Extract<"accessibilityHint", keyof Result_9> | Extract<"accessibilityValue", keyof Result_9> | Extract<"onAccessibilityAction", keyof Result_9> | Extract<"accessibilityLiveRegion", keyof Result_9> | Extract<"importantForAccessibility", keyof Result_9> | Extract<"accessibilityElementsHidden", keyof Result_9> | Extract<"accessibilityViewIsModal", keyof Result_9> | Extract<"onAccessibilityEscape", keyof Result_9> | Extract<"onAccessibilityTap", keyof Result_9> | Extract<"onMagicTap", keyof Result_9> | Extract<"accessibilityIgnoresInvertColors", keyof Result_9> | Extract<"rnCSS", keyof Result_9> | Extract<"onMouseEnter", keyof Result_9> | Extract<"onMouseLeave", keyof Result_9> | Extract<"onSnapshotReady", keyof Result_9> | Extract<"testIdentifier", keyof Result_9>>>> & React.RefAttributes<any>>;
    };
    Switch: {
        <S_10>(chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: S_10 & RN.SwitchProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]): React.ForwardRefExoticComponent<RN.SwitchProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & S_10 & {
            ref?: React.Ref<any> | undefined;
        }>;
        attrs<Part_10, Result_10 extends Partial<RN.SwitchProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_10> = Partial<RN.SwitchProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_10>>(opts: Result_10 | ((props: RN.SwitchProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_10) => Result_10)): (chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: RN.SwitchProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_10 & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]) => React.ForwardRefExoticComponent<React.PropsWithoutRef<Omit<RN.SwitchProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, keyof Result_10> & Part_10 & Partial<Pick<RN.SwitchProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, Extract<"testID", keyof Result_10> | Extract<"tintColor", keyof Result_10> | Extract<"value", keyof Result_10> | Extract<"onFocus", keyof Result_10> | Extract<"onBlur", keyof Result_10> | Extract<"onPressIn", keyof Result_10> | Extract<"onPressOut", keyof Result_10> | Extract<"onResponderStart", keyof Result_10> | Extract<"onResponderRelease", keyof Result_10> | Extract<"onStartShouldSetResponder", keyof Result_10> | Extract<"onLayout", keyof Result_10> | Extract<"removeClippedSubviews", keyof Result_10> | Extract<"style", keyof Result_10> | Extract<"children", keyof Result_10> | Extract<"hitSlop", keyof Result_10> | Extract<"pointerEvents", keyof Result_10> | Extract<"nativeID", keyof Result_10> | Extract<"collapsable", keyof Result_10> | Extract<"needsOffscreenAlphaCompositing", keyof Result_10> | Extract<"renderToHardwareTextureAndroid", keyof Result_10> | Extract<"focusable", keyof Result_10> | Extract<"shouldRasterizeIOS", keyof Result_10> | Extract<"isTVSelectable", keyof Result_10> | Extract<"hasTVPreferredFocus", keyof Result_10> | Extract<"tvParallaxProperties", keyof Result_10> | Extract<"tvParallaxShiftDistanceX", keyof Result_10> | Extract<"tvParallaxShiftDistanceY", keyof Result_10> | Extract<"tvParallaxTiltAngle", keyof Result_10> | Extract<"tvParallaxMagnification", keyof Result_10> | Extract<"onMoveShouldSetResponder", keyof Result_10> | Extract<"onResponderEnd", keyof Result_10> | Extract<"onResponderGrant", keyof Result_10> | Extract<"onResponderReject", keyof Result_10> | Extract<"onResponderMove", keyof Result_10> | Extract<"onResponderTerminationRequest", keyof Result_10> | Extract<"onResponderTerminate", keyof Result_10> | Extract<"onStartShouldSetResponderCapture", keyof Result_10> | Extract<"onMoveShouldSetResponderCapture", keyof Result_10> | Extract<"onTouchStart", keyof Result_10> | Extract<"onTouchMove", keyof Result_10> | Extract<"onTouchEnd", keyof Result_10> | Extract<"onTouchCancel", keyof Result_10> | Extract<"onTouchEndCapture", keyof Result_10> | Extract<"accessible", keyof Result_10> | Extract<"accessibilityActions", keyof Result_10> | Extract<"accessibilityLabel", keyof Result_10> | Extract<"accessibilityRole", keyof Result_10> | Extract<"accessibilityState", keyof Result_10> | Extract<"accessibilityHint", keyof Result_10> | Extract<"accessibilityValue", keyof Result_10> | Extract<"onAccessibilityAction", keyof Result_10> | Extract<"accessibilityLiveRegion", keyof Result_10> | Extract<"importantForAccessibility", keyof Result_10> | Extract<"accessibilityElementsHidden", keyof Result_10> | Extract<"accessibilityViewIsModal", keyof Result_10> | Extract<"onAccessibilityEscape", keyof Result_10> | Extract<"onAccessibilityTap", keyof Result_10> | Extract<"onMagicTap", keyof Result_10> | Extract<"accessibilityIgnoresInvertColors", keyof Result_10> | Extract<"rnCSS", keyof Result_10> | Extract<"onMouseEnter", keyof Result_10> | Extract<"onMouseLeave", keyof Result_10> | Extract<"thumbColor", keyof Result_10> | Extract<"trackColor", keyof Result_10> | Extract<"disabled", keyof Result_10> | Extract<"onChange", keyof Result_10> | Extract<"onValueChange", keyof Result_10> | Extract<"ios_backgroundColor", keyof Result_10> | Extract<"onTintColor", keyof Result_10> | Extract<"thumbTintColor", keyof Result_10>>>> & React.RefAttributes<any>>;
    };
    RecyclerViewBackedScrollView: {
        <S_11>(chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: S_11 & RN.RecyclerViewBackedScrollViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]): React.ForwardRefExoticComponent<RN.RecyclerViewBackedScrollViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & S_11 & {
            ref?: React.Ref<any> | undefined;
        }>;
        attrs<Part_11, Result_11 extends Partial<RN.RecyclerViewBackedScrollViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_11> = Partial<RN.RecyclerViewBackedScrollViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_11>>(opts: Result_11 | ((props: RN.RecyclerViewBackedScrollViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_11) => Result_11)): (chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: RN.RecyclerViewBackedScrollViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_11 & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]) => React.ForwardRefExoticComponent<React.PropsWithoutRef<Omit<RN.RecyclerViewBackedScrollViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, keyof Result_11> & Part_11 & Partial<Pick<RN.RecyclerViewBackedScrollViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, Extract<"testID", keyof Result_11> | Extract<"onFocus", keyof Result_11> | Extract<"onBlur", keyof Result_11> | Extract<"onPressIn", keyof Result_11> | Extract<"onPressOut", keyof Result_11> | Extract<"onResponderStart", keyof Result_11> | Extract<"onResponderRelease", keyof Result_11> | Extract<"onStartShouldSetResponder", keyof Result_11> | Extract<"onLayout", keyof Result_11> | Extract<"keyboardShouldPersistTaps", keyof Result_11> | Extract<"horizontal", keyof Result_11> | Extract<"removeClippedSubviews", keyof Result_11> | Extract<"fadingEdgeLength", keyof Result_11> | Extract<"contentContainerStyle", keyof Result_11> | Extract<"decelerationRate", keyof Result_11> | Extract<"invertStickyHeaders", keyof Result_11> | Extract<"keyboardDismissMode", keyof Result_11> | Extract<"onContentSizeChange", keyof Result_11> | Extract<"onScroll", keyof Result_11> | Extract<"onScrollBeginDrag", keyof Result_11> | Extract<"onScrollEndDrag", keyof Result_11> | Extract<"onMomentumScrollEnd", keyof Result_11> | Extract<"onMomentumScrollBegin", keyof Result_11> | Extract<"pagingEnabled", keyof Result_11> | Extract<"scrollEnabled", keyof Result_11> | Extract<"showsHorizontalScrollIndicator", keyof Result_11> | Extract<"showsVerticalScrollIndicator", keyof Result_11> | Extract<"stickyHeaderHiddenOnScroll", keyof Result_11> | Extract<"style", keyof Result_11> | Extract<"refreshControl", keyof Result_11> | Extract<"snapToInterval", keyof Result_11> | Extract<"snapToOffsets", keyof Result_11> | Extract<"snapToStart", keyof Result_11> | Extract<"snapToEnd", keyof Result_11> | Extract<"stickyHeaderIndices", keyof Result_11> | Extract<"disableIntervalMomentum", keyof Result_11> | Extract<"disableScrollViewPanResponder", keyof Result_11> | Extract<"StickyHeaderComponent", keyof Result_11> | Extract<"children", keyof Result_11> | Extract<"hitSlop", keyof Result_11> | Extract<"pointerEvents", keyof Result_11> | Extract<"nativeID", keyof Result_11> | Extract<"collapsable", keyof Result_11> | Extract<"needsOffscreenAlphaCompositing", keyof Result_11> | Extract<"renderToHardwareTextureAndroid", keyof Result_11> | Extract<"focusable", keyof Result_11> | Extract<"shouldRasterizeIOS", keyof Result_11> | Extract<"isTVSelectable", keyof Result_11> | Extract<"hasTVPreferredFocus", keyof Result_11> | Extract<"tvParallaxProperties", keyof Result_11> | Extract<"tvParallaxShiftDistanceX", keyof Result_11> | Extract<"tvParallaxShiftDistanceY", keyof Result_11> | Extract<"tvParallaxTiltAngle", keyof Result_11> | Extract<"tvParallaxMagnification", keyof Result_11> | Extract<"onMoveShouldSetResponder", keyof Result_11> | Extract<"onResponderEnd", keyof Result_11> | Extract<"onResponderGrant", keyof Result_11> | Extract<"onResponderReject", keyof Result_11> | Extract<"onResponderMove", keyof Result_11> | Extract<"onResponderTerminationRequest", keyof Result_11> | Extract<"onResponderTerminate", keyof Result_11> | Extract<"onStartShouldSetResponderCapture", keyof Result_11> | Extract<"onMoveShouldSetResponderCapture", keyof Result_11> | Extract<"onTouchStart", keyof Result_11> | Extract<"onTouchMove", keyof Result_11> | Extract<"onTouchEnd", keyof Result_11> | Extract<"onTouchCancel", keyof Result_11> | Extract<"onTouchEndCapture", keyof Result_11> | Extract<"accessible", keyof Result_11> | Extract<"accessibilityActions", keyof Result_11> | Extract<"accessibilityLabel", keyof Result_11> | Extract<"accessibilityRole", keyof Result_11> | Extract<"accessibilityState", keyof Result_11> | Extract<"accessibilityHint", keyof Result_11> | Extract<"accessibilityValue", keyof Result_11> | Extract<"onAccessibilityAction", keyof Result_11> | Extract<"accessibilityLiveRegion", keyof Result_11> | Extract<"importantForAccessibility", keyof Result_11> | Extract<"accessibilityElementsHidden", keyof Result_11> | Extract<"accessibilityViewIsModal", keyof Result_11> | Extract<"onAccessibilityEscape", keyof Result_11> | Extract<"onAccessibilityTap", keyof Result_11> | Extract<"onMagicTap", keyof Result_11> | Extract<"accessibilityIgnoresInvertColors", keyof Result_11> | Extract<"alwaysBounceHorizontal", keyof Result_11> | Extract<"alwaysBounceVertical", keyof Result_11> | Extract<"automaticallyAdjustContentInsets", keyof Result_11> | Extract<"bounces", keyof Result_11> | Extract<"bouncesZoom", keyof Result_11> | Extract<"canCancelContentTouches", keyof Result_11> | Extract<"centerContent", keyof Result_11> | Extract<"contentInset", keyof Result_11> | Extract<"contentOffset", keyof Result_11> | Extract<"contentInsetAdjustmentBehavior", keyof Result_11> | Extract<"directionalLockEnabled", keyof Result_11> | Extract<"indicatorStyle", keyof Result_11> | Extract<"maintainVisibleContentPosition", keyof Result_11> | Extract<"maximumZoomScale", keyof Result_11> | Extract<"minimumZoomScale", keyof Result_11> | Extract<"onScrollAnimationEnd", keyof Result_11> | Extract<"pinchGestureEnabled", keyof Result_11> | Extract<"scrollEventThrottle", keyof Result_11> | Extract<"scrollIndicatorInsets", keyof Result_11> | Extract<"scrollToOverflowEnabled", keyof Result_11> | Extract<"scrollsToTop", keyof Result_11> | Extract<"snapToAlignment", keyof Result_11> | Extract<"onScrollToTop", keyof Result_11> | Extract<"zoomScale", keyof Result_11> | Extract<"endFillColor", keyof Result_11> | Extract<"scrollPerfTag", keyof Result_11> | Extract<"overScrollMode", keyof Result_11> | Extract<"nestedScrollEnabled", keyof Result_11> | Extract<"persistentScrollbar", keyof Result_11> | Extract<"rnCSS", keyof Result_11> | Extract<"onMouseEnter", keyof Result_11> | Extract<"onMouseLeave", keyof Result_11>>>> & React.RefAttributes<any>>;
    };
    RefreshControl: {
        <S_12>(chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: S_12 & RN.RefreshControlProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]): React.ForwardRefExoticComponent<RN.RefreshControlProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & S_12 & {
            ref?: React.Ref<any> | undefined;
        }>;
        attrs<Part_12, Result_12 extends Partial<RN.RefreshControlProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_12> = Partial<RN.RefreshControlProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_12>>(opts: Result_12 | ((props: RN.RefreshControlProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_12) => Result_12)): (chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: RN.RefreshControlProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_12 & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]) => React.ForwardRefExoticComponent<React.PropsWithoutRef<Omit<RN.RefreshControlProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, keyof Result_12> & Part_12 & Partial<Pick<RN.RefreshControlProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, Extract<"enabled", keyof Result_12> | Extract<"testID", keyof Result_12> | Extract<"tintColor", keyof Result_12> | Extract<"onFocus", keyof Result_12> | Extract<"onBlur", keyof Result_12> | Extract<"onPressIn", keyof Result_12> | Extract<"onPressOut", keyof Result_12> | Extract<"onResponderStart", keyof Result_12> | Extract<"onResponderRelease", keyof Result_12> | Extract<"onStartShouldSetResponder", keyof Result_12> | Extract<"onLayout", keyof Result_12> | Extract<"onRefresh", keyof Result_12> | Extract<"refreshing", keyof Result_12> | Extract<"removeClippedSubviews", keyof Result_12> | Extract<"progressViewOffset", keyof Result_12> | Extract<"style", keyof Result_12> | Extract<"children", keyof Result_12> | Extract<"hitSlop", keyof Result_12> | Extract<"pointerEvents", keyof Result_12> | Extract<"nativeID", keyof Result_12> | Extract<"collapsable", keyof Result_12> | Extract<"needsOffscreenAlphaCompositing", keyof Result_12> | Extract<"renderToHardwareTextureAndroid", keyof Result_12> | Extract<"focusable", keyof Result_12> | Extract<"shouldRasterizeIOS", keyof Result_12> | Extract<"isTVSelectable", keyof Result_12> | Extract<"hasTVPreferredFocus", keyof Result_12> | Extract<"tvParallaxProperties", keyof Result_12> | Extract<"tvParallaxShiftDistanceX", keyof Result_12> | Extract<"tvParallaxShiftDistanceY", keyof Result_12> | Extract<"tvParallaxTiltAngle", keyof Result_12> | Extract<"tvParallaxMagnification", keyof Result_12> | Extract<"onMoveShouldSetResponder", keyof Result_12> | Extract<"onResponderEnd", keyof Result_12> | Extract<"onResponderGrant", keyof Result_12> | Extract<"onResponderReject", keyof Result_12> | Extract<"onResponderMove", keyof Result_12> | Extract<"onResponderTerminationRequest", keyof Result_12> | Extract<"onResponderTerminate", keyof Result_12> | Extract<"onStartShouldSetResponderCapture", keyof Result_12> | Extract<"onMoveShouldSetResponderCapture", keyof Result_12> | Extract<"onTouchStart", keyof Result_12> | Extract<"onTouchMove", keyof Result_12> | Extract<"onTouchEnd", keyof Result_12> | Extract<"onTouchCancel", keyof Result_12> | Extract<"onTouchEndCapture", keyof Result_12> | Extract<"accessible", keyof Result_12> | Extract<"accessibilityActions", keyof Result_12> | Extract<"accessibilityLabel", keyof Result_12> | Extract<"accessibilityRole", keyof Result_12> | Extract<"accessibilityState", keyof Result_12> | Extract<"accessibilityHint", keyof Result_12> | Extract<"accessibilityValue", keyof Result_12> | Extract<"onAccessibilityAction", keyof Result_12> | Extract<"accessibilityLiveRegion", keyof Result_12> | Extract<"importantForAccessibility", keyof Result_12> | Extract<"accessibilityElementsHidden", keyof Result_12> | Extract<"accessibilityViewIsModal", keyof Result_12> | Extract<"onAccessibilityEscape", keyof Result_12> | Extract<"onAccessibilityTap", keyof Result_12> | Extract<"onMagicTap", keyof Result_12> | Extract<"accessibilityIgnoresInvertColors", keyof Result_12> | Extract<"rnCSS", keyof Result_12> | Extract<"onMouseEnter", keyof Result_12> | Extract<"onMouseLeave", keyof Result_12> | Extract<"title", keyof Result_12> | Extract<"size", keyof Result_12> | Extract<"titleColor", keyof Result_12> | Extract<"colors", keyof Result_12> | Extract<"progressBackgroundColor", keyof Result_12>>>> & React.RefAttributes<any>>;
    };
    SafeAreaView: {
        <S_13>(chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: S_13 & RN.ViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]): React.ForwardRefExoticComponent<RN.ViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & S_13 & {
            ref?: React.Ref<any> | undefined;
        }>;
        attrs<Part_13, Result_13 extends Partial<RN.ViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_13> = Partial<RN.ViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_13>>(opts: Result_13 | ((props: RN.ViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_13) => Result_13)): (chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: RN.ViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_13 & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]) => React.ForwardRefExoticComponent<React.PropsWithoutRef<Omit<RN.ViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, keyof Result_13> & Part_13 & Partial<Pick<RN.ViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, Extract<"testID", keyof Result_13> | Extract<"onFocus", keyof Result_13> | Extract<"onBlur", keyof Result_13> | Extract<"onPressIn", keyof Result_13> | Extract<"onPressOut", keyof Result_13> | Extract<"onResponderStart", keyof Result_13> | Extract<"onResponderRelease", keyof Result_13> | Extract<"onStartShouldSetResponder", keyof Result_13> | Extract<"onLayout", keyof Result_13> | Extract<"removeClippedSubviews", keyof Result_13> | Extract<"style", keyof Result_13> | Extract<"children", keyof Result_13> | Extract<"hitSlop", keyof Result_13> | Extract<"pointerEvents", keyof Result_13> | Extract<"nativeID", keyof Result_13> | Extract<"collapsable", keyof Result_13> | Extract<"needsOffscreenAlphaCompositing", keyof Result_13> | Extract<"renderToHardwareTextureAndroid", keyof Result_13> | Extract<"focusable", keyof Result_13> | Extract<"shouldRasterizeIOS", keyof Result_13> | Extract<"isTVSelectable", keyof Result_13> | Extract<"hasTVPreferredFocus", keyof Result_13> | Extract<"tvParallaxProperties", keyof Result_13> | Extract<"tvParallaxShiftDistanceX", keyof Result_13> | Extract<"tvParallaxShiftDistanceY", keyof Result_13> | Extract<"tvParallaxTiltAngle", keyof Result_13> | Extract<"tvParallaxMagnification", keyof Result_13> | Extract<"onMoveShouldSetResponder", keyof Result_13> | Extract<"onResponderEnd", keyof Result_13> | Extract<"onResponderGrant", keyof Result_13> | Extract<"onResponderReject", keyof Result_13> | Extract<"onResponderMove", keyof Result_13> | Extract<"onResponderTerminationRequest", keyof Result_13> | Extract<"onResponderTerminate", keyof Result_13> | Extract<"onStartShouldSetResponderCapture", keyof Result_13> | Extract<"onMoveShouldSetResponderCapture", keyof Result_13> | Extract<"onTouchStart", keyof Result_13> | Extract<"onTouchMove", keyof Result_13> | Extract<"onTouchEnd", keyof Result_13> | Extract<"onTouchCancel", keyof Result_13> | Extract<"onTouchEndCapture", keyof Result_13> | Extract<"accessible", keyof Result_13> | Extract<"accessibilityActions", keyof Result_13> | Extract<"accessibilityLabel", keyof Result_13> | Extract<"accessibilityRole", keyof Result_13> | Extract<"accessibilityState", keyof Result_13> | Extract<"accessibilityHint", keyof Result_13> | Extract<"accessibilityValue", keyof Result_13> | Extract<"onAccessibilityAction", keyof Result_13> | Extract<"accessibilityLiveRegion", keyof Result_13> | Extract<"importantForAccessibility", keyof Result_13> | Extract<"accessibilityElementsHidden", keyof Result_13> | Extract<"accessibilityViewIsModal", keyof Result_13> | Extract<"onAccessibilityEscape", keyof Result_13> | Extract<"onAccessibilityTap", keyof Result_13> | Extract<"onMagicTap", keyof Result_13> | Extract<"accessibilityIgnoresInvertColors", keyof Result_13> | Extract<"rnCSS", keyof Result_13> | Extract<"onMouseEnter", keyof Result_13> | Extract<"onMouseLeave", keyof Result_13>>>> & React.RefAttributes<any>>;
    };
    Text: {
        <S_14>(chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: S_14 & RN.TextProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]): React.ForwardRefExoticComponent<RN.TextProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & S_14 & {
            ref?: React.Ref<any> | undefined;
        }>;
        attrs<Part_14, Result_14 extends Partial<RN.TextProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_14> = Partial<RN.TextProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_14>>(opts: Result_14 | ((props: RN.TextProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_14) => Result_14)): (chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: RN.TextProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_14 & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]) => React.ForwardRefExoticComponent<React.PropsWithoutRef<Omit<RN.TextProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, keyof Result_14> & Part_14 & Partial<Pick<RN.TextProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, Extract<"testID", keyof Result_14> | Extract<"onFocus", keyof Result_14> | Extract<"onBlur", keyof Result_14> | Extract<"onPressIn", keyof Result_14> | Extract<"onPressOut", keyof Result_14> | Extract<"onResponderStart", keyof Result_14> | Extract<"onResponderRelease", keyof Result_14> | Extract<"onStartShouldSetResponder", keyof Result_14> | Extract<"onLayout", keyof Result_14> | Extract<"style", keyof Result_14> | Extract<"children", keyof Result_14> | Extract<"nativeID", keyof Result_14> | Extract<"accessible", keyof Result_14> | Extract<"accessibilityActions", keyof Result_14> | Extract<"accessibilityLabel", keyof Result_14> | Extract<"accessibilityRole", keyof Result_14> | Extract<"accessibilityState", keyof Result_14> | Extract<"accessibilityHint", keyof Result_14> | Extract<"accessibilityValue", keyof Result_14> | Extract<"onAccessibilityAction", keyof Result_14> | Extract<"accessibilityLiveRegion", keyof Result_14> | Extract<"importantForAccessibility", keyof Result_14> | Extract<"accessibilityElementsHidden", keyof Result_14> | Extract<"accessibilityViewIsModal", keyof Result_14> | Extract<"onAccessibilityEscape", keyof Result_14> | Extract<"onAccessibilityTap", keyof Result_14> | Extract<"onMagicTap", keyof Result_14> | Extract<"accessibilityIgnoresInvertColors", keyof Result_14> | Extract<"rnCSS", keyof Result_14> | Extract<"onMouseEnter", keyof Result_14> | Extract<"onMouseLeave", keyof Result_14> | Extract<"allowFontScaling", keyof Result_14> | Extract<"ellipsizeMode", keyof Result_14> | Extract<"lineBreakMode", keyof Result_14> | Extract<"numberOfLines", keyof Result_14> | Extract<"onTextLayout", keyof Result_14> | Extract<"onPress", keyof Result_14> | Extract<"onLongPress", keyof Result_14> | Extract<"maxFontSizeMultiplier", keyof Result_14> | Extract<"adjustsFontSizeToFit", keyof Result_14> | Extract<"minimumFontScale", keyof Result_14> | Extract<"suppressHighlighting", keyof Result_14> | Extract<"selectable", keyof Result_14> | Extract<"selectionColor", keyof Result_14> | Extract<"textBreakStrategy", keyof Result_14> | Extract<"dataDetectorType", keyof Result_14> | Extract<"android_hyphenationFrequency", keyof Result_14>>>> & React.RefAttributes<any>>;
    };
    TextInput: {
        <S_15>(chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: S_15 & RN.TextInputProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]): React.ForwardRefExoticComponent<RN.TextInputProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & S_15 & {
            ref?: React.Ref<any> | undefined;
        }>;
        attrs<Part_15, Result_15 extends Partial<RN.TextInputProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_15> = Partial<RN.TextInputProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_15>>(opts: Result_15 | ((props: RN.TextInputProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_15) => Result_15)): (chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: RN.TextInputProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_15 & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]) => React.ForwardRefExoticComponent<React.PropsWithoutRef<Omit<RN.TextInputProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, keyof Result_15> & Part_15 & Partial<Pick<RN.TextInputProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, Extract<"testID", keyof Result_15> | Extract<"textAlign", keyof Result_15> | Extract<"textAlignVertical", keyof Result_15> | Extract<"value", keyof Result_15> | Extract<"onFocus", keyof Result_15> | Extract<"onBlur", keyof Result_15> | Extract<"onPressIn", keyof Result_15> | Extract<"onPressOut", keyof Result_15> | Extract<"onResponderStart", keyof Result_15> | Extract<"onResponderRelease", keyof Result_15> | Extract<"onStartShouldSetResponder", keyof Result_15> | Extract<"onLayout", keyof Result_15> | Extract<"removeClippedSubviews", keyof Result_15> | Extract<"onContentSizeChange", keyof Result_15> | Extract<"onScroll", keyof Result_15> | Extract<"scrollEnabled", keyof Result_15> | Extract<"style", keyof Result_15> | Extract<"children", keyof Result_15> | Extract<"hitSlop", keyof Result_15> | Extract<"pointerEvents", keyof Result_15> | Extract<"nativeID", keyof Result_15> | Extract<"collapsable", keyof Result_15> | Extract<"needsOffscreenAlphaCompositing", keyof Result_15> | Extract<"renderToHardwareTextureAndroid", keyof Result_15> | Extract<"focusable", keyof Result_15> | Extract<"shouldRasterizeIOS", keyof Result_15> | Extract<"isTVSelectable", keyof Result_15> | Extract<"hasTVPreferredFocus", keyof Result_15> | Extract<"tvParallaxProperties", keyof Result_15> | Extract<"tvParallaxShiftDistanceX", keyof Result_15> | Extract<"tvParallaxShiftDistanceY", keyof Result_15> | Extract<"tvParallaxTiltAngle", keyof Result_15> | Extract<"tvParallaxMagnification", keyof Result_15> | Extract<"onMoveShouldSetResponder", keyof Result_15> | Extract<"onResponderEnd", keyof Result_15> | Extract<"onResponderGrant", keyof Result_15> | Extract<"onResponderReject", keyof Result_15> | Extract<"onResponderMove", keyof Result_15> | Extract<"onResponderTerminationRequest", keyof Result_15> | Extract<"onResponderTerminate", keyof Result_15> | Extract<"onStartShouldSetResponderCapture", keyof Result_15> | Extract<"onMoveShouldSetResponderCapture", keyof Result_15> | Extract<"onTouchStart", keyof Result_15> | Extract<"onTouchMove", keyof Result_15> | Extract<"onTouchEnd", keyof Result_15> | Extract<"onTouchCancel", keyof Result_15> | Extract<"onTouchEndCapture", keyof Result_15> | Extract<"accessible", keyof Result_15> | Extract<"accessibilityActions", keyof Result_15> | Extract<"accessibilityLabel", keyof Result_15> | Extract<"accessibilityRole", keyof Result_15> | Extract<"accessibilityState", keyof Result_15> | Extract<"accessibilityHint", keyof Result_15> | Extract<"accessibilityValue", keyof Result_15> | Extract<"onAccessibilityAction", keyof Result_15> | Extract<"accessibilityLiveRegion", keyof Result_15> | Extract<"importantForAccessibility", keyof Result_15> | Extract<"accessibilityElementsHidden", keyof Result_15> | Extract<"accessibilityViewIsModal", keyof Result_15> | Extract<"onAccessibilityEscape", keyof Result_15> | Extract<"onAccessibilityTap", keyof Result_15> | Extract<"onMagicTap", keyof Result_15> | Extract<"accessibilityIgnoresInvertColors", keyof Result_15> | Extract<"rnCSS", keyof Result_15> | Extract<"onMouseEnter", keyof Result_15> | Extract<"onMouseLeave", keyof Result_15> | Extract<"onChange", keyof Result_15> | Extract<"allowFontScaling", keyof Result_15> | Extract<"numberOfLines", keyof Result_15> | Extract<"maxFontSizeMultiplier", keyof Result_15> | Extract<"selectionColor", keyof Result_15> | Extract<"textBreakStrategy", keyof Result_15> | Extract<"autoCapitalize", keyof Result_15> | Extract<"autoCorrect", keyof Result_15> | Extract<"autoFocus", keyof Result_15> | Extract<"blurOnSubmit", keyof Result_15> | Extract<"caretHidden", keyof Result_15> | Extract<"contextMenuHidden", keyof Result_15> | Extract<"defaultValue", keyof Result_15> | Extract<"editable", keyof Result_15> | Extract<"keyboardType", keyof Result_15> | Extract<"maxLength", keyof Result_15> | Extract<"multiline", keyof Result_15> | Extract<"onChangeText", keyof Result_15> | Extract<"onEndEditing", keyof Result_15> | Extract<"onSelectionChange", keyof Result_15> | Extract<"onSubmitEditing", keyof Result_15> | Extract<"onTextInput", keyof Result_15> | Extract<"onKeyPress", keyof Result_15> | Extract<"placeholder", keyof Result_15> | Extract<"placeholderTextColor", keyof Result_15> | Extract<"returnKeyType", keyof Result_15> | Extract<"secureTextEntry", keyof Result_15> | Extract<"selectTextOnFocus", keyof Result_15> | Extract<"selection", keyof Result_15> | Extract<"inputAccessoryViewID", keyof Result_15> | Extract<"clearButtonMode", keyof Result_15> | Extract<"clearTextOnFocus", keyof Result_15> | Extract<"dataDetectorTypes", keyof Result_15> | Extract<"enablesReturnKeyAutomatically", keyof Result_15> | Extract<"keyboardAppearance", keyof Result_15> | Extract<"passwordRules", keyof Result_15> | Extract<"rejectResponderTermination", keyof Result_15> | Extract<"selectionState", keyof Result_15> | Extract<"spellCheck", keyof Result_15> | Extract<"textContentType", keyof Result_15> | Extract<"autoComplete", keyof Result_15> | Extract<"importantForAutofill", keyof Result_15> | Extract<"disableFullscreenUI", keyof Result_15> | Extract<"inlineImageLeft", keyof Result_15> | Extract<"inlineImagePadding", keyof Result_15> | Extract<"returnKeyLabel", keyof Result_15> | Extract<"underlineColorAndroid", keyof Result_15> | Extract<"showSoftInputOnFocus", keyof Result_15>>>> & React.RefAttributes<any>>;
    };
    TouchableHighlight: {
        <S_16>(chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: S_16 & RN.TouchableHighlightProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]): React.ForwardRefExoticComponent<RN.TouchableHighlightProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & S_16 & {
            ref?: React.Ref<any> | undefined;
        }>;
        attrs<Part_16, Result_16 extends Partial<RN.TouchableHighlightProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_16> = Partial<RN.TouchableHighlightProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_16>>(opts: Result_16 | ((props: RN.TouchableHighlightProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_16) => Result_16)): (chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: RN.TouchableHighlightProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_16 & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]) => React.ForwardRefExoticComponent<React.PropsWithoutRef<Omit<RN.TouchableHighlightProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, keyof Result_16> & Part_16 & Partial<Pick<RN.TouchableHighlightProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, Extract<"testID", keyof Result_16> | Extract<"onFocus", keyof Result_16> | Extract<"onBlur", keyof Result_16> | Extract<"onPressIn", keyof Result_16> | Extract<"onPressOut", keyof Result_16> | Extract<"onResponderStart", keyof Result_16> | Extract<"onResponderRelease", keyof Result_16> | Extract<"onStartShouldSetResponder", keyof Result_16> | Extract<"onLayout", keyof Result_16> | Extract<"style", keyof Result_16> | Extract<"children", keyof Result_16> | Extract<"hitSlop", keyof Result_16> | Extract<"accessible", keyof Result_16> | Extract<"accessibilityActions", keyof Result_16> | Extract<"accessibilityLabel", keyof Result_16> | Extract<"accessibilityRole", keyof Result_16> | Extract<"accessibilityState", keyof Result_16> | Extract<"accessibilityHint", keyof Result_16> | Extract<"accessibilityValue", keyof Result_16> | Extract<"onAccessibilityAction", keyof Result_16> | Extract<"accessibilityLiveRegion", keyof Result_16> | Extract<"importantForAccessibility", keyof Result_16> | Extract<"accessibilityElementsHidden", keyof Result_16> | Extract<"accessibilityViewIsModal", keyof Result_16> | Extract<"onAccessibilityEscape", keyof Result_16> | Extract<"onAccessibilityTap", keyof Result_16> | Extract<"onMagicTap", keyof Result_16> | Extract<"accessibilityIgnoresInvertColors", keyof Result_16> | Extract<"rnCSS", keyof Result_16> | Extract<"onMouseEnter", keyof Result_16> | Extract<"onMouseLeave", keyof Result_16> | Extract<"disabled", keyof Result_16> | Extract<"onPress", keyof Result_16> | Extract<"onLongPress", keyof Result_16> | Extract<"activeOpacity", keyof Result_16> | Extract<"onHideUnderlay", keyof Result_16> | Extract<"onShowUnderlay", keyof Result_16> | Extract<"underlayColor", keyof Result_16> | Extract<"delayLongPress", keyof Result_16> | Extract<"delayPressIn", keyof Result_16> | Extract<"delayPressOut", keyof Result_16> | Extract<"pressRetentionOffset", keyof Result_16> | Extract<"touchSoundDisabled", keyof Result_16>>>> & React.RefAttributes<any>>;
    };
    TouchableNativeFeedback: {
        <S_17>(chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: S_17 & RN.TouchableNativeFeedbackProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]): React.ForwardRefExoticComponent<RN.TouchableNativeFeedbackProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & S_17 & {
            ref?: React.Ref<any> | undefined;
        }>;
        attrs<Part_17, Result_17 extends Partial<RN.TouchableNativeFeedbackProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_17> = Partial<RN.TouchableNativeFeedbackProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_17>>(opts: Result_17 | ((props: RN.TouchableNativeFeedbackProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_17) => Result_17)): (chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: RN.TouchableNativeFeedbackProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_17 & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]) => React.ForwardRefExoticComponent<React.PropsWithoutRef<Omit<RN.TouchableNativeFeedbackProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, keyof Result_17> & Part_17 & Partial<Pick<RN.TouchableNativeFeedbackProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, Extract<"testID", keyof Result_17> | Extract<"onFocus", keyof Result_17> | Extract<"onBlur", keyof Result_17> | Extract<"background", keyof Result_17> | Extract<"onPressIn", keyof Result_17> | Extract<"onPressOut", keyof Result_17> | Extract<"onResponderStart", keyof Result_17> | Extract<"onResponderRelease", keyof Result_17> | Extract<"onStartShouldSetResponder", keyof Result_17> | Extract<"onLayout", keyof Result_17> | Extract<"style", keyof Result_17> | Extract<"children", keyof Result_17> | Extract<"hitSlop", keyof Result_17> | Extract<"hasTVPreferredFocus", keyof Result_17> | Extract<"accessible", keyof Result_17> | Extract<"accessibilityActions", keyof Result_17> | Extract<"accessibilityLabel", keyof Result_17> | Extract<"accessibilityRole", keyof Result_17> | Extract<"accessibilityState", keyof Result_17> | Extract<"accessibilityHint", keyof Result_17> | Extract<"accessibilityValue", keyof Result_17> | Extract<"onAccessibilityAction", keyof Result_17> | Extract<"accessibilityLiveRegion", keyof Result_17> | Extract<"importantForAccessibility", keyof Result_17> | Extract<"accessibilityElementsHidden", keyof Result_17> | Extract<"accessibilityViewIsModal", keyof Result_17> | Extract<"onAccessibilityEscape", keyof Result_17> | Extract<"onAccessibilityTap", keyof Result_17> | Extract<"onMagicTap", keyof Result_17> | Extract<"accessibilityIgnoresInvertColors", keyof Result_17> | Extract<"rnCSS", keyof Result_17> | Extract<"onMouseEnter", keyof Result_17> | Extract<"onMouseLeave", keyof Result_17> | Extract<"disabled", keyof Result_17> | Extract<"onPress", keyof Result_17> | Extract<"onLongPress", keyof Result_17> | Extract<"delayLongPress", keyof Result_17> | Extract<"delayPressIn", keyof Result_17> | Extract<"delayPressOut", keyof Result_17> | Extract<"pressRetentionOffset", keyof Result_17> | Extract<"touchSoundDisabled", keyof Result_17> | Extract<"useForeground", keyof Result_17> | Extract<"nextFocusDown", keyof Result_17> | Extract<"nextFocusForward", keyof Result_17> | Extract<"nextFocusLeft", keyof Result_17> | Extract<"nextFocusRight", keyof Result_17> | Extract<"nextFocusUp", keyof Result_17>>>> & React.RefAttributes<any>>;
    };
    TouchableOpacity: {
        <S_18>(chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: S_18 & RN.TouchableOpacityProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]): React.ForwardRefExoticComponent<RN.TouchableOpacityProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & S_18 & {
            ref?: React.Ref<any> | undefined;
        }>;
        attrs<Part_18, Result_18 extends Partial<RN.TouchableOpacityProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_18> = Partial<RN.TouchableOpacityProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_18>>(opts: Result_18 | ((props: RN.TouchableOpacityProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_18) => Result_18)): (chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: RN.TouchableOpacityProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_18 & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]) => React.ForwardRefExoticComponent<React.PropsWithoutRef<Omit<RN.TouchableOpacityProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, keyof Result_18> & Part_18 & Partial<Pick<RN.TouchableOpacityProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, Extract<"testID", keyof Result_18> | Extract<"onFocus", keyof Result_18> | Extract<"onBlur", keyof Result_18> | Extract<"onPressIn", keyof Result_18> | Extract<"onPressOut", keyof Result_18> | Extract<"onResponderStart", keyof Result_18> | Extract<"onResponderRelease", keyof Result_18> | Extract<"onStartShouldSetResponder", keyof Result_18> | Extract<"onLayout", keyof Result_18> | Extract<"style", keyof Result_18> | Extract<"children", keyof Result_18> | Extract<"hitSlop", keyof Result_18> | Extract<"hasTVPreferredFocus", keyof Result_18> | Extract<"tvParallaxProperties", keyof Result_18> | Extract<"accessible", keyof Result_18> | Extract<"accessibilityActions", keyof Result_18> | Extract<"accessibilityLabel", keyof Result_18> | Extract<"accessibilityRole", keyof Result_18> | Extract<"accessibilityState", keyof Result_18> | Extract<"accessibilityHint", keyof Result_18> | Extract<"accessibilityValue", keyof Result_18> | Extract<"onAccessibilityAction", keyof Result_18> | Extract<"accessibilityLiveRegion", keyof Result_18> | Extract<"importantForAccessibility", keyof Result_18> | Extract<"accessibilityElementsHidden", keyof Result_18> | Extract<"accessibilityViewIsModal", keyof Result_18> | Extract<"onAccessibilityEscape", keyof Result_18> | Extract<"onAccessibilityTap", keyof Result_18> | Extract<"onMagicTap", keyof Result_18> | Extract<"accessibilityIgnoresInvertColors", keyof Result_18> | Extract<"rnCSS", keyof Result_18> | Extract<"onMouseEnter", keyof Result_18> | Extract<"onMouseLeave", keyof Result_18> | Extract<"disabled", keyof Result_18> | Extract<"onPress", keyof Result_18> | Extract<"onLongPress", keyof Result_18> | Extract<"activeOpacity", keyof Result_18> | Extract<"delayLongPress", keyof Result_18> | Extract<"delayPressIn", keyof Result_18> | Extract<"delayPressOut", keyof Result_18> | Extract<"pressRetentionOffset", keyof Result_18> | Extract<"touchSoundDisabled", keyof Result_18> | Extract<"nextFocusDown", keyof Result_18> | Extract<"nextFocusForward", keyof Result_18> | Extract<"nextFocusLeft", keyof Result_18> | Extract<"nextFocusRight", keyof Result_18> | Extract<"nextFocusUp", keyof Result_18>>>> & React.RefAttributes<any>>;
    };
    TouchableWithoutFeedback: {
        <S_19>(chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: S_19 & RN.TouchableWithoutFeedbackProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]): React.ForwardRefExoticComponent<RN.TouchableWithoutFeedbackProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & S_19 & {
            ref?: React.Ref<any> | undefined;
        }>;
        attrs<Part_19, Result_19 extends Partial<RN.TouchableWithoutFeedbackProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_19> = Partial<RN.TouchableWithoutFeedbackProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_19>>(opts: Result_19 | ((props: RN.TouchableWithoutFeedbackProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_19) => Result_19)): (chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: RN.TouchableWithoutFeedbackProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_19 & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]) => React.ForwardRefExoticComponent<React.PropsWithoutRef<Omit<RN.TouchableWithoutFeedbackProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, keyof Result_19> & Part_19 & Partial<Pick<RN.TouchableWithoutFeedbackProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, Extract<"testID", keyof Result_19> | Extract<"onFocus", keyof Result_19> | Extract<"onBlur", keyof Result_19> | Extract<"onPressIn", keyof Result_19> | Extract<"onPressOut", keyof Result_19> | Extract<"onResponderStart", keyof Result_19> | Extract<"onResponderRelease", keyof Result_19> | Extract<"onStartShouldSetResponder", keyof Result_19> | Extract<"onLayout", keyof Result_19> | Extract<"style", keyof Result_19> | Extract<"children", keyof Result_19> | Extract<"hitSlop", keyof Result_19> | Extract<"accessible", keyof Result_19> | Extract<"accessibilityActions", keyof Result_19> | Extract<"accessibilityLabel", keyof Result_19> | Extract<"accessibilityRole", keyof Result_19> | Extract<"accessibilityState", keyof Result_19> | Extract<"accessibilityHint", keyof Result_19> | Extract<"accessibilityValue", keyof Result_19> | Extract<"onAccessibilityAction", keyof Result_19> | Extract<"accessibilityLiveRegion", keyof Result_19> | Extract<"importantForAccessibility", keyof Result_19> | Extract<"accessibilityElementsHidden", keyof Result_19> | Extract<"accessibilityViewIsModal", keyof Result_19> | Extract<"onAccessibilityEscape", keyof Result_19> | Extract<"onAccessibilityTap", keyof Result_19> | Extract<"onMagicTap", keyof Result_19> | Extract<"accessibilityIgnoresInvertColors", keyof Result_19> | Extract<"rnCSS", keyof Result_19> | Extract<"onMouseEnter", keyof Result_19> | Extract<"onMouseLeave", keyof Result_19> | Extract<"disabled", keyof Result_19> | Extract<"onPress", keyof Result_19> | Extract<"onLongPress", keyof Result_19> | Extract<"delayLongPress", keyof Result_19> | Extract<"delayPressIn", keyof Result_19> | Extract<"delayPressOut", keyof Result_19> | Extract<"pressRetentionOffset", keyof Result_19> | Extract<"touchSoundDisabled", keyof Result_19>>>> & React.RefAttributes<any>>;
    };
    View: {
        <S_13>(chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: S_13 & RN.ViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]): React.ForwardRefExoticComponent<RN.ViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & S_13 & {
            ref?: React.Ref<any> | undefined;
        }>;
        attrs<Part_13, Result_13 extends Partial<RN.ViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_13> = Partial<RN.ViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_13>>(opts: Result_13 | ((props: RN.ViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_13) => Result_13)): (chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: RN.ViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & Part_13 & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]) => React.ForwardRefExoticComponent<React.PropsWithoutRef<Omit<RN.ViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, keyof Result_13> & Part_13 & Partial<Pick<RN.ViewProps & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, Extract<"testID", keyof Result_13> | Extract<"onFocus", keyof Result_13> | Extract<"onBlur", keyof Result_13> | Extract<"onPressIn", keyof Result_13> | Extract<"onPressOut", keyof Result_13> | Extract<"onResponderStart", keyof Result_13> | Extract<"onResponderRelease", keyof Result_13> | Extract<"onStartShouldSetResponder", keyof Result_13> | Extract<"onLayout", keyof Result_13> | Extract<"removeClippedSubviews", keyof Result_13> | Extract<"style", keyof Result_13> | Extract<"children", keyof Result_13> | Extract<"hitSlop", keyof Result_13> | Extract<"pointerEvents", keyof Result_13> | Extract<"nativeID", keyof Result_13> | Extract<"collapsable", keyof Result_13> | Extract<"needsOffscreenAlphaCompositing", keyof Result_13> | Extract<"renderToHardwareTextureAndroid", keyof Result_13> | Extract<"focusable", keyof Result_13> | Extract<"shouldRasterizeIOS", keyof Result_13> | Extract<"isTVSelectable", keyof Result_13> | Extract<"hasTVPreferredFocus", keyof Result_13> | Extract<"tvParallaxProperties", keyof Result_13> | Extract<"tvParallaxShiftDistanceX", keyof Result_13> | Extract<"tvParallaxShiftDistanceY", keyof Result_13> | Extract<"tvParallaxTiltAngle", keyof Result_13> | Extract<"tvParallaxMagnification", keyof Result_13> | Extract<"onMoveShouldSetResponder", keyof Result_13> | Extract<"onResponderEnd", keyof Result_13> | Extract<"onResponderGrant", keyof Result_13> | Extract<"onResponderReject", keyof Result_13> | Extract<"onResponderMove", keyof Result_13> | Extract<"onResponderTerminationRequest", keyof Result_13> | Extract<"onResponderTerminate", keyof Result_13> | Extract<"onStartShouldSetResponderCapture", keyof Result_13> | Extract<"onMoveShouldSetResponderCapture", keyof Result_13> | Extract<"onTouchStart", keyof Result_13> | Extract<"onTouchMove", keyof Result_13> | Extract<"onTouchEnd", keyof Result_13> | Extract<"onTouchCancel", keyof Result_13> | Extract<"onTouchEndCapture", keyof Result_13> | Extract<"accessible", keyof Result_13> | Extract<"accessibilityActions", keyof Result_13> | Extract<"accessibilityLabel", keyof Result_13> | Extract<"accessibilityRole", keyof Result_13> | Extract<"accessibilityState", keyof Result_13> | Extract<"accessibilityHint", keyof Result_13> | Extract<"accessibilityValue", keyof Result_13> | Extract<"onAccessibilityAction", keyof Result_13> | Extract<"accessibilityLiveRegion", keyof Result_13> | Extract<"importantForAccessibility", keyof Result_13> | Extract<"accessibilityElementsHidden", keyof Result_13> | Extract<"accessibilityViewIsModal", keyof Result_13> | Extract<"onAccessibilityEscape", keyof Result_13> | Extract<"onAccessibilityTap", keyof Result_13> | Extract<"onMagicTap", keyof Result_13> | Extract<"accessibilityIgnoresInvertColors", keyof Result_13> | Extract<"rnCSS", keyof Result_13> | Extract<"onMouseEnter", keyof Result_13> | Extract<"onMouseLeave", keyof Result_13>>>> & React.RefAttributes<any>>;
    };
    FlatList: {
        <S_20>(chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: S_20 & RN.FlatListProps<any> & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]): <Type>(props: S_20 & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & RN.FlatListProps<Type>) => JSX.Element;
        attrs<S_21, Result_20 extends Partial<S_21 & RN.FlatListProps<any> & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }> = {}>(opts: Result_20 | ((props: S_21 & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & RN.FlatListProps<any>) => Result_20)): (chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: S_21 & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]) => <Props>(componentProps: Omit<RN.FlatListProps<Props> & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, keyof Result_20> & S_21 & Partial<Result_20>) => JSX.Element;
    };
    SectionList: {
        <S_22>(chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: S_22 & RN.SectionListProps<any, RN.DefaultSectionT> & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]): <Type_1>(props: S_22 & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & RN.SectionListProps<Type_1, RN.DefaultSectionT>) => JSX.Element;
        attrs<S_23, Result_21 extends Partial<S_23 & RN.SectionListProps<any, RN.DefaultSectionT> & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }> = {}>(opts: Result_21 | ((props: S_23 & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & RN.SectionListProps<any, RN.DefaultSectionT>) => Result_21)): (chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: S_23 & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]) => <Props_1>(componentProps: Omit<RN.SectionListProps<Props_1, RN.DefaultSectionT> & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, keyof Result_21> & S_23 & Partial<Result_21>) => JSX.Element;
    };
    VirtualizedList: {
        <S_24>(chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: S_24 & RN.VirtualizedListProps<any> & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]): <Type_2>(props: S_24 & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & RN.VirtualizedListProps<Type_2>) => JSX.Element;
        attrs<S_25, Result_22 extends Partial<S_25 & RN.VirtualizedListProps<any> & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }> = {}>(opts: Result_22 | ((props: S_25 & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        } & RN.VirtualizedListProps<any>) => Result_22)): (chunks: TemplateStringsArray, ...functs: ((string | number | boolean | import("./types").CompleteStyle | null | undefined) | ((arg: S_25 & {
            rnCSS?: string | undefined;
            shared: unknown;
            theme: import("./styleComponent").DefaultTheme;
        }) => string | number | boolean | import("./types").CompleteStyle | null | undefined))[]) => <Props_2>(componentProps: Omit<RN.VirtualizedListProps<Props_2> & {
            rnCSS?: `${string};` | undefined;
            onFocus?: import("./features").FocusEventListener;
            onBlur?: import("./features").BlurEventListener;
            onPressIn?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onPressOut?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderStart?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onResponderRelease?: ((event: RN.GestureResponderEvent) => void) | undefined;
            onStartShouldSetResponder?: ((event: RN.GestureResponderEvent) => boolean) | undefined;
            onMouseEnter?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onMouseLeave?: ((event: React.MouseEvent<Element, MouseEvent>) => void) | undefined;
            onLayout?: ((event: RN.LayoutChangeEvent) => void) | undefined;
            children?: React.ReactNode;
        }, keyof Result_22> & S_25 & Partial<Result_22>) => JSX.Element;
    };
};
export default styled;
